#!/usr/bin/perl
#######################################################
#                                                     #
#  Kapcsoldsi, statisztikai adatkielemz s         #
#  megjelent program, mely rsze az                 #
#   ***    GPRS Easy Connect programnak         ***   #
# A programot Simon Pter (Perl Tk) s Pintr Gbor   #
# (kapcsoldsi szkriptek) ksztette.                #
# simon.peter@linuxuser.hu, pinter.gabor@linuxuser.hu #
# (felttlenl olvasd el a LICENSE llomnyt)         #
#                                                     #
# Connection program, part of the GPRS Easy Connect   #
# software made by Peter Simon and Gabor Pinter.      #
#  This program come under GNU GPL.                   #
#                                                     #
#######################################################


$ver="V2.5.3";

# distribution?
$m_KernelName = `uname -s`;
$dist_kern = `uname -a`;
chomp ($m_KernelName);
chomp ($dist_kern);

if ($m_KernelName eq "Linux") {
	$gprs_shared_path="/usr/share";
	$gprs_bin_path="/usr/bin";
	$fullong=1000;
}

if ($m_KernelName eq "FreeBSD") {
	$gprs_shared_path="/usr/local/share";
	$gprs_bin_path="/usr/local/bin";
	$fullong=70;
}

#$fgh=@futgprs;
@fgh=`ps ax | grep "/usr/bin/perl" | grep "gprsec"\$`;
$l_fgh=@fgh;

if ($l_fgh<1) {
	print "\nThis file is part of GPRS Easy Connect program,\nyou can\'t run this file directly!\n";
	print "\nPress <enter>";
	$qwe=<STDIN>;
	exit;
}

use Tk;
use Socket;
use Tk::Balloon;
use LWP::Simple;
#read resolution
$xvidtune=`xvidtune -show`;
$xvidtune=~s /(\"\d+)x(\d+\")/$1.$2/e;
$xvhor=$1;
$xvver=$2;
$xvhor=~ tr /\"//d;
$xvver=~ tr /\"//d;;
$xfele=$xvhor/2;
$yfele=$xvver/2;

$home=$ENV{"HOME"};
$kivagy=`whoami`;
chomp $kivagy;

# every new wile is not runable
umask 0111;

# read the config
#open (FILE, "<$home/.gprsec/EasyConn.config");
#$sor=<FILE>;
#close FILE;
#@spl=split /\:/, $sor;
#$co_pan=$spl[2];
#$brow=$spl[3];
#$brow_on=$spl[4];
read_conf ();

# read the language
nyelvbeolv ();

# there's no auhority for the pppd
sleep 1; # wait 1 second for the start of pppd
if (!-x "/usr/sbin/pppd") {
	$winconn2=MainWindow->new();
	$winconn2->title ("GPRS Easy Connect");
		$winconn2x=$xfele-100;
		$winconn2y=$yfele-50;
		$winconn2->geometry("+$winconn2x+$winconn2y");
	if ($no_beep !=1) {
		$winconn2->bell;
	}
	$noauth_sz=$winconn2->Label(-fg=>'red', -text=>lancolas($cl[67]))->pack(); # nincs jogosultsg a pppd-hez (ekkor nem jn ltre a conn.log)
	$noauth_b=$winconn2->Button(-text=>"Ok", -command=>\sub {exit})->pack();
	$winconn2->OnDestroy(\sub {exit});
MainLoop ();
}

`chmod 0666 '$home/.gprsec/conn.log'`;
$readwin=MainWindow->new();
$readwin->OnDestroy(\sub {return(); write_last7days()});
$readwin->title (lancolas ($cl[20])); #Kapcsolds folyamatban...
$xfele=$xvhor/2;
$greadwin=$xfele-261;
$readwin->geometry("+$greadwin+0");
$disc_file="$home/.gprsec/re";

if (-e $disc_file) {
	`rm $disc_file`;
	if ($bg_rec!=0) {
	$readwin->iconify;
	}
}

$kapcswin=$readwin->Frame(-relief=>'sunken', -bd=>2)->pack(-side=>'top');
$aframe=$readwin->Frame()->pack();
$readwin->maxsize('523','138');
$readwin->minsize('523','138');

$k1=$kapcswin->Label()->pack();
$tux=$kapcswin->Label(-image=>$kapcswin->Photo(-file=>"$gprs_shared_path/gprsec/images/wstux.xpm"),
	-border=>0);
$tux->pack(-side=>'left');
$earth=$kapcswin->Label(-image=>$kapcswin->Photo(-file=>"$gprs_shared_path/gprsec/images/w1.gif"),
	-border=>0);
$earth->pack(-side=>'right');
$hat_on="off";

$downfr=$kapcswin->Frame()->pack(-side=>'bottom');

$stat_b=$downfr->Button(-text=>lancolas($cl[50]), -command=>\&onoff)->pack(-side=>'left'); #Statisztikai adatokat mutat/elrejt
$spec_button=$downfr->Button(-text=>lancolas($cl[51]), -command=>\&spec_stat)->pack(-side=>'right'); #Specilis statisztika

if ($no_dev) {
	$stat_b->configure(-state=>"disable");
	$spec_button->configure(-state=>"disable");
}

$uzframe=$kapcswin->Frame()->pack(-side=>'bottom');

$uzenet=$uzframe->Label(-fg=>'red', -width=>50, -height=>5, -fg=>'blue', -textvariable=>\lancolas($cl[20]))->pack(); #A kapcsolds folyamatban...



# watching algorythms:
	# watching of echoes of pppd
	$kapcstime=time;

	$id = $kapcswin->repeat($idores,=>\&be);
	# watching of state of connection
	$jd = $kapcswin->repeat(10,=>\&cont);

$kapcswin->OnDestroy(\&kill_pppd);

canvas_cucc ();


# if there's no statistic file, then this method makes one
if (!-e "$home/.gprsec/sp_stat") {
	$tempfilename=">$home/.gprsec/sp_stat";
	open (FILE, $tempfilename);
	chmod 0666, $tempfilename;
	for ($x=1; $x<=288; $x++) {
		print FILE "$x\:\:\:\n";
	}
	close FILE;
}

# repairing the statistic file
$egesz=`cat '$home/.gprsec/sp_stat'`;
@egall=split /\n/, $egesz;
foreach (@egall) {
	@act_line=split /\:/, $_;
	if ($act_line[3]>7) {
		$_="$act_line[0]:0:0:0";
	}
}

$tempfilename=">$home/.gprsec/sp_stat";
open (FILE, $tempfilename);
chmod 0666, $tempfilename;
foreach (@egall) {
	print FILE "$_\n";
}


sub canvas_cucc {
# making if statistics canvas
		$hat=$aframe->Canvas(-width=>523, -height=>480)->pack(-side=>'left');
		# show of elements of statistics
	# all transmitted data
		# dowbloaded bytes
  		if (-e "$home/.gprsec/osszb_le") {
			$ob_l_v=`cat '$home/.gprsec/osszb_le'`;
		}
		$start_y=16;

		$regtimekezd_szov=$hat->Label(-text=>lancolas($cl[84])); #kezdet ideje
		$hat->createWindow(10, $start_y+0, -window=>$regtimekezd_szov, -anchor=>'w' ); # kezd. id?
		$regtimekezd_v=$hat->Label(); #kezdet ideje
		$hat->createWindow(343, $start_y+0, -window=>$regtimekezd_v, -anchor=>'w' ); # kezd. id?

		$ob_l_szov=$hat->Label(-text=>lancolas($cl[28], $kivagy)); #Az EasyConnal sszesen letlttt adatok:
		$hat->createWindow(10, $start_y+20, -window=>$ob_l_szov, -anchor=>'w' );
		$ob_l=$hat->Label();
		$hat->createWindow(353, $start_y+20, -window=>$ob_l, -anchor=>'w' );
		# uploaded bytes
		if (-e "$home/.gprsec/osszb_fel") {
			$ob_f_v=`cat '$home/.gprsec/osszb_fel'`;
		}
		$ob_f_szov=$hat->Label(-text=>lancolas($cl[29], $kivagy)); #Az EasyConnal sszesen feltlttt adatok:
		$hat->createWindow(10, $start_y+40, -window=>$ob_f_szov, -anchor=>'w' );

		$ob_f=$hat->Label();
		$hat->createWindow(353, $start_y+40, -window=>$ob_f, -anchor=>'w' );


		$osszlefel_sz_sz=$hat->Label(-text=>lancolas($cl[109])); #sszesen Forgalmazott adatmennyisg:
		$hat->createWindow(10, $start_y+60, -window=>$osszlefel_sz_sz, -anchor=>'w' );
		$osszlefel_sz=$hat->Label(); #fe s le
		$hat->createWindow(353, $start_y+60, -window=>$osszlefel_sz, -anchor=>'w' ); #fe s le

		$hetiforg_sz=$hat->Label(-text=>lancolas($cl[110])); #Az elmlt ht nap foglama:
		$hat->createWindow(10, $start_y+80, -window=>$hetiforg_sz, -anchor=>'w' );
		$hetiforg_v=$hat->Label();
		$hat->createWindow(353, $start_y+80, -window=>$hetiforg_v, -anchor=>'w' );

		# graphical borderline
		$hat->createLine(0, $start_y+95, 523, $start_y+95);
		# transmitted data
		$ad_fel_sz=$hat->Label(-text=>lancolas ($cl[30])); #Forgalmazott adatmennyisg:
		$hat->createWindow(230, $start_y+110, -window=>$ad_fel_sz, -anchor=>'center' );
			# bytes down
			$ad_le_b_sz=$hat->Label(-text=>lancolas($cl[31])); #Bjtokban le:
			$hat->createWindow(10, $start_y+130, -window=>$ad_le_b_sz, -anchor=>'w' );
			$ad_le_b=$hat->Label();
			$hat->createWindow(157, $start_y+130, -window=>$ad_le_b, -anchor=>'w' );
			# bytes up
			$ad_fel_b_sz=$hat->Label(-text=>lancolas($cl[32])); #Bjtokban fel:
			$hat->createWindow(10, $start_y+150, -window=>$ad_fel_b_sz, -anchor=>'w' );
			$ad_fel_b=$hat->Label();
			$hat->createWindow(157, $start_y+150, -window=>$ad_fel_b, -anchor=>'w' );
			# package down
			$ad_le_cs_sz=$hat->Label(-text=>lancolas($cl[33])); #Csomag le:
			$hat->createWindow(270, $start_y+130, -window=>$ad_le_cs_sz, -anchor=>'w' );
			$ad_le_cs=$hat->Label();
			$hat->createWindow(415, $start_y+130, -window=>$ad_le_cs, -anchor=>'w' );
			# package up
			$ad_fel_cs_sz=$hat->Label(-text=>lancolas($cl[34])); #Csomag fel:
			$hat->createWindow(270, $start_y+150, -window=>$ad_fel_cs_sz, -anchor=>'w' );
			$ad_fel_cs=$hat->Label();
			$hat->createWindow(415, $start_y+150, -window=>$ad_fel_cs, -anchor=>'w' );
		# graphical borderline
		$hat->createLine(0, $start_y+165, 523, $start_y+165);
		# avarage speed of the active connection
		$akt_atl_sz=$hat->Label(-text=>lancolas($cl[35])); #Az aktv kapcsolat adatforgalmi tlagsebessge:
		$hat->createWindow(10, $start_y+180, -window=>$akt_atl_sz, -anchor=>'w' );
		$akt_atl_v=$hat->Label();
		$hat->createWindow(353, $start_y+180, -window=>$akt_atl_v, -anchor=>'w' );
		# graphical borderline
		$hat->createLine(0, $start_y+195, 523, $start_y+195);
		# connection times
			# this connection's time
			$kapcs_t_sz=$hat->Label(-text=>lancolas ($cl[36])); #A kapcsolat idtartama:
			$hat->createWindow(10, $start_y+210, -window=>$kapcs_t_sz, -anchor=>'w' );
			$kapcs_t_v=$hat->Label();
			$hat->createWindow(353, $start_y+210, -window=>$kapcs_t_v, -anchor=>'w' );
			# all
			$kapcs_o_sz=$hat->Label(-text=>lancolas ($cl[37])); #Az sszes kapcsolat idtartama:
			$hat->createWindow(10, $start_y+230, -window=>$kapcs_o_sz, -anchor=>'w' );
			$kapcs_o_v=$hat->Label();
			$hat->createWindow(353, $start_y+230, -window=>$kapcs_o_v, -anchor=>'w' );
			if (-e "$home/.gprsec/ossz_ido") {
				$kapcs_idok=`cat '$home/.gprsec/ossz_ido'`;
			}

		$stime=time;
		# graphical borderline
		$hat->createLine(0, $start_y+245, 523, $start_y+245);
		# momentary speed
			# down
			$ad_l_pill_sz=$hat->Label(-text=>lancolas ($cl[38])); #Pillanatnyi letltsi sebessg:
			$hat->createWindow(10, $start_y+260, -window=>$ad_l_pill_sz, -anchor=>'w' );
			$ad_l_pill=$hat->Label(-fg=>'red');
			$hat->createWindow(353, $start_y+260, -window=>$ad_l_pill, -anchor=>'w' );
			# up
			$ad_f_pill_sz=$hat->Label(-text=>lancolas($cl[39])); #Pillanatnyi feltltsi sebessg:
			$hat->createWindow(10, $start_y+280, -window=>$ad_f_pill_sz, -anchor=>'w' );
			$ad_f_pill=$hat->Label(-fg=>'blue');
			$hat->createWindow(353, $start_y+280, -window=>$ad_f_pill, -anchor=>'w' );

MainLoop();
}

sub be {
	if (-e "$home/.gprsec/conn.log") {
		$connlog=`cat $home/.gprsec/conn.log`; # reads the all echoes of pppd
		$a=`tail -n 1 $home/.gprsec/conn.log`; # reads the last line of pppd's echo
	}

	######
	$_=$a;
	######
	if (/ERROR/) {
		$id->cancel;
		$jd->cancel;
		beep ();
		red_col ();
		$uzenet->configure(-textvariable=>\lancolas($cl[21])); #Kapcsoldsi hiba!
		red ();
		reconn ();
		return ();
	}
	if (/is locked by pid/) {
		$id->cancel;
		$jd->cancel;
		@vege = split / /, $_;
		$hossz=@vege;
		$hossz--;
		chop ($vege[$hossz]);
		beep ();
		red_col ();
		$uzenet->configure(-textvariable=>\lancolas ($cl[22]," $vege[$hossz] ")); #A***folyamat mr hasznlja,....
		red ();

		$manual_kill_win=MainWindow->new();
		$manual_kill_win->title (lancolas($cl[21]));
		$manual_kill_win->maxsize('380','60');
		$manual_kill_win->minsize('380','60');
			$manual_kill_winx=$xfele-190;
			$manual_kill_winy=$yfele-30;
			$manual_kill_win->geometry("+$manual_kill_winx+$manual_kill_winy");
		$kill_sz=$manual_kill_win->Label(-fg=>'red', -text=>lancolas($cl[176]))->pack();#"There\'s a frozen pppd process!\nMay I try to kill this frozen process now?"
		$kill_but=$manual_kill_win->Button(-text=>lancolas($cl[93]), -command=>\&kill_frozen)->pack(-side=>"right");
		$kill_but_no=$manual_kill_win->Button(-text=>lancolas($cl[57]), -command=>sub {exit})->pack(-side=>"left");
		MainLoop();

		sub kill_frozen {
			$temp_pppd_pid=`ps ax | grep "\\[pp\pd\\]"\$`;
			if (!$temp_pppd_pid) {
				$temp_pppd_pid=`ps ax | grep "/usr/sbin/pp\pd file $home/.gprsec/run"\$`;
			}
			@pppd_pid=split /\n/, $temp_pppd_pid;
			if (@pppd_pid) {
				foreach (@pppd_pid) {
					$_=~ s/(\d+)/$1/e;
					if ($1 eq $vege[$hossz]) {
						`kill -KILL "$vege[$hossz]"`;
					}
				}
			}
		$manual_kill_win->destroy;
		undef $manual_kill_win;
		$readwin->destroy;
		}

		return ();
	}
	if ($_ eq $a && /expect \(OK\)/) {
		$percent->after(100);
		$_=`tail -n 1 $home/.gprsec/conn.log`;
		if (/expect \(OK\)/) {
			red_col ();
			$id->cancel;
			$jd->cancel;
			$uzenet->configure(-textvariable=>\lancolas($cl[23])); #A kapcsolatpts a vrakozsi ...
			beep ();
			red ();
			reconn ();
			return ();
		}
	}
	if (/\^|\@/) {
		$id->cancel;
		$jd->cancel;
		beep ();
		red_col ();
		$uzenet->configure(-fg=>'red', -textvariable=>\lancolas($cl[24])); # gy tnik, a telefont ...
		$cimke=100;
		red ();
		return ();
	}
	###########
	$_=$connlog;
	###########
	if (m/No network protocols running/) {
		$id->cancel;
		$jd->cancel;
		beep ();
		red_col ();
		$uzenet->configure(-textvariable=>\lancolas($cl[40])); #A kapcsoldsi folymat megszakadt.\nA GPRS hlzat terhelt!
		red ();
		reconn ();
		return ();
	}
	if (/LCP terminated by peer/) {
		$id->cancel;
		$jd->cancel;
		beep ();
		red_col ();
		$uzenet->configure(-textvariable=>\lancolas($cl[27])); #A kapcsoldsi folymat megszakadt.\nNincs vlasz a hlzattl.
		red ();
		reconn ();
		return ();
	}
	if (/Connect script failed/) {
		$id->cancel;
		$jd->cancel;
		beep ();
		red_col ();
		$uzenet->configure(-textvariable=>\lancolas($cl[41])); #Konfigurcis hiba miatt a kapcsolds\nfolymata megszakadt.\nEllenrizd a belltsaidat!
		red ();
		return ();
	}
	if (/Connection terminated./ && !/LCP terminated by peer/) {
		$id->cancel;
		$jd->cancel;
		beep ();
		red_col ();
		$uzenet->configure(-textvariable=>\lancolas($cl[42])); #Felhasznli megszakts.\nEsetleg a telefon lemerlt.\nVagy kicsszott az adatkbel.
		red ();
		return ();
	}
	if (/not replacing existing default/) {
		$hova=$_;
		$hova=~ s/to\ (\S+)\ \[/$1/e;
		$droute=$1;
		hiba(lancolas("Warning! The can't change the default route, it's still $droute!")); #Figyelem! Nem sikerlt az internetes adatforgalmat a GPRS-hez rendleni!\nA(z) $droute az alaprtelmezett tovbbra is!
	}
	
	
	$kapcstime_here=time;
	$kapcstime_dif=$kapcstime_here-$kapcstime;
	if (($a eq "\r" || $a eq "\n" || $kapcstime_dif>20) && ($m_KernelName ne "FreeBSD")) { # there are line and marks, or the connection method idles for 20 sec.
		$kapcswin->after(1000); # now then, we check it in one second. Is there any change?

		$ell=`tail -n 1 '$home/.gprsec/conn.log'`;
		if ($ell eq "\r" || $a eq "\n" || $kapcstime_dif>30) {
			$id->cancel;
			$jd->cancel;
			beep ();
			red_col ();
			$uzenet->configure(-textvariable=>\lancolas ($cl[52])); #csatlakozsi folyamat kls....
			red ();
			reconn ();
			return ();
		}
	}

	# checking the successfull connection under FreeBSD
	if ($m_KernelName eq "FreeBSD") {
		$bsd_pppd_id=`ps ax | grep "/usr/sbin/pppd file $home/.gprsec/run"\$`;
		$bsd_pppd_id=~ s/(\d+)/$1/e;
		$bsd_pppd_id=$1;

		@bsd_pppd_mess_lines=`tail -n 10 /var/log/messages`; #last 10 lines

		foreach (@bsd_pppd_mess_lines) {
			if (/pppd\[$bsd_pppd_id\]/) {
				if (/local  IP address /) {
					$_=~ s/local  IP address (\d+\.\d+\.\d+\.\d+)/$1/e;
					$local[1]=$1;
				}
				if (/remote IP address /) {
					$_=~ s/remote IP address (\d+\.\d+\.\d+\.\d+)/$1/e;
					$remote[1]=$1;
				}
				if ($local[1] && $remote[1]) {
					$id->cancel;
					$jd->cancel;
					$resolv_file=`cat '/etc/resolv.conf'`;
					@resolv=split/\n/, $resolv_file;
					foreach (@resolv) {
						if (/nameserver/) {
							push (@dns, $_);
						}
					}
					@primary=split/ /, $dns[0];
					@secondary=split/ /, $dns[1];
					#readwin->title (lancolas ($cl[25])); #Kapcsolds sikeres!
					$cimke=100;
					$uzenet->configure(-fg=>'blue', -textvariable=>\lancolas($cl[26], $local[1], $remote[1], $primary[1], $secondary[1])); #A kapcsoldsi folyamat sikeresen...
					if ($co_pan==1){
						$readwin->iconify;
					}
					open (FILE, ">$home/.gprsec/dns");
					print FILE "$primary[1]\n$secondary[1]";
					close FILE;
					
					# makes the cycle for watching the disconnection
					$watch=$kapcswin->repeat (500,=>\&watch);
					# makes a cycle for the data transmission's read and processing
					if (!$no_dev or $no_dev eq "0") {
						$indtime=time; # start time for logging
						dbmopen (%NAP, "$home/.gprsec/7d", 0666);
						%DAYS=%NAP;
						dbmclose (%NAP);
						$dev=$aframe->repeat(1000,=>\&devs);
					}
					#geting information from the server about the tested or the non-tested phone
					$clean_tel_name=$phonetype;
					$clean_tel_name =~ tr/\*//d;
					$tested_phone_inf= get ("http://easyconnect.linuxuser.hu/test.php?phone=$clean_tel_name");
					
					#it's not tested
					if ($tested_phone_inf="0" && !$no_find) {
						findnotested();
					}
				}
			}
		}
	}

	# checking the successfull connection under Linux
	if ($m_KernelName eq "Linux") {
		$a=`tail -n 1 $home/.gprsec/conn.log`; # sampling under running of watching algorythm
		###########
		$_=$connlog;
		###########
		if (/Script \/etc\/ppp\/ip-up finished/ || (/local\ \ IP\ address\ / && /remote\ IP\ address\ /)) {
			$id->cancel;
			$jd->cancel;
			$readwin->title (lancolas ($cl[25])); #Kapcsolds sikeres!
			$cimke=100;

			@mind=split /\n/,$connlog;
			foreach (@mind) {
				if (/local  IP address /) {
					@local=split/local  IP address /, $_;
				}
				if (/remote IP address /) {
					@remote=split/remote IP address /, $_;
				}
				if (/primary   DNS address /) {
					@primary=split/primary   DNS address /, $_;
					$d1=1;
				}
				if (/secondary DNS address /) {
					@secondary=split/secondary DNS address /, $_;
					$d2=1;
				}
 			}
			if (!$d1 && !$d2) {
				$resolv_file=`cat '/etc/resolv.conf'`;
				@resolv=split/\n/, $resolv_file;
				foreach (@resolv) {
					if (/nameserver/) {
						push (@dns, $_);
					}
				}
				@primary=split/ /, $dns[0];
				@secondary=split/ /, $dns[1];
			}
			$uzenet->configure(-fg=>'blue', -textvariable=>\lancolas($cl[26], $local[1], $remote[1], $primary[1], $secondary[1])); #A kapcsoldsi folyamat sikeresen...
			if ($co_pan==1){
				$readwin->iconify;
			}
			open (FILE, ">$home/.gprsec/dns");
			print FILE "$primary[1]\n$secondary[1]";
			close FILE;
			
			# makes the cycle for watching the disconnection
			#$watch=$kapcswin->repeat (5000,=>\&watch);
			# makes a cycle for the data transmission's read and processing
			if (!$no_dev or $no_dev eq "0") {
						$indtime=time; # start time for logging
						dbmopen (%NAP, "$home/.gprsec/7d", 0666);
						%DAYS=%NAP;
						dbmclose (%NAP);
						$dev=$aframe->repeat(1000,=>\&devs);
			}

			#geting information from the server about the tested or the non-tested phone
			$clean_tel_name=$phonetype;
			$clean_tel_name =~ tr/\*//d;
			$tested_phone_inf= get ("http://easyconnect.linuxuser.hu/test.php?phone=$clean_tel_name");
			chomp ($tested_phone_inf);
						
			#it's not tested
			if ($tested_phone_inf eq "0" && !$no_find) {
				findnotested();
			}
		}
	}
	######
	$_=$a;
	######
	if (/Failed to open/ && /Permission denied/) {
		$id->cancel;
		$jd->cancel;
		beep ();
		red_col ();
		$uzenet->configure(-textvariable=>\lancolas($cl[41])); #Konfigurcis hiba miatt a kapcsolds\nfolymata megszakadt.\nEllenrizd a belltsaidat!
		red ();
		return ();
	}

	if (!$_) { # the conn.log is empty!!!
		$readwin->after(2000); # now then we check it in 2 second
		$_=`tail -n 1 '$home/.gprsec/conn.log'`;
		$len_=length($_);
			if (!$_ || length($_)<3) {
			$hmm_proba++;
			$id->cancel;
			$jd->cancel;
			beep ();
			red_col ();
			$uzenet->configure(-textvariable=>\lancolas($cl[124])); #Hmm... Valami nem ok. Ezer oka lehet...\nPrblj jra csatlakozni, vagy konfigurlni.\nHa akkor sem megy, akkor bugreportolj, lgy szves!
			red ();
			reconn ();
			return ();
		}
	}
} # end of analizing of errors and successfull connection's sub



sub cont {
	# calculating the data of statusline's show
	$sorok=`wc -c $home/.gprsec/conn.log`;
	$sorok=~tr /[0-9]//cd;
	$szazal=int(($sorok/$fullong)*100);
	$_=$connlog;
	$cimke=$_;
	$cimke=$szazal." %, $tort";
	$nev=int($cimke/10);
	if ($nev>10) {$nev=10}
	$tomb=$nev*10;
	$akthoz=$cimke-$lastsz;
	$akthoz=int($akthoz/1.74);
	for ($x=1; $x<=$akthoz; $x++) {
		$szaml++;
		if ($szaml<50) {
			$graf[$szaml]=$kapcswin->Label(-image=>$kapcswin->Photo(-file=>"$gprs_shared_path/gprsec/images/tb.xpm"),
			-border=>1, -bg=>'black');
			$graf[$szaml]->pack(-side=>'left');
		}
	}
	$lastsz=$cimke;
}

# watching of disconnect (if the connection is alive already)
sub watch {
	if ($m_KernelName eq "Linux") {
		$a=`cat '$home/.gprsec/conn.log'`;
		$qwe++;
		$_=$a;
		if (/Serial link disconnected/ || /LCP terminated by peer/ || /Connection terminated/) {
			$readwin->title (lancolas($cl[43])); #A kapcsolat megszakadt!
			$watch->cancel;
#			$id->cancel;
#			$jd->cancel;
			$dev->cancel;
			if ($bg_rec!=0) {
				$readwin->iconify;
			} else {
				$readwin->raise;
				$readwin->deiconify;
			}
			$uzenet->configure(-fg=>'red', -textvariable=>\lancolas($cl[43]));
			red ();
			beep ();
			reconn ();
			return;
		}
	}

	if ($m_KernelName eq "FreeBSD") {
		@bsd_pppd_mess_lines=`tail -n 3 /var/log/messages`; #last 10 lines
		foreach (@bsd_pppd_mess_lines) {
			if (/pppd\[$bsd_pppd_id\]/) {
				if (/Connection terminated/) {
					$readwin->title (lancolas($cl[43])); #A kapcsolat megszakadt!
					$watch->cancel;
#					$id->cancel;
#					$jd->cancel;
					$dev->cancel;
					if ($bg_rec!=0) {
						$readwin->iconify;
					} else {
						$readwin->raise;
						$readwin->deiconify;
					}
					$uzenet->configure(-fg=>'red', -textvariable=>\lancolas($cl[43]));
					red ();
					beep ();
					reconn ();
					return;
				}
			}
		}
	}
}
# if the connection is terminated then the text will be red in the connection window
sub red_col {
	$uzenet->configure(-fg=>'red');
}

# if the connection is terminated then the statusline's small rectangles turn red
sub red {
	$lastsz_sz=$lastsz;
	$lastsz_sz=~tr / %,//d;
	for ($x=1; $x<=$lastsz_sz; $x++) {
		if ($graf[$x]) {$graf[$x]->destroy;
			$graf[$x]=$kapcswin->Label(-image=>$kapcswin->Photo(-file=>"$gprs_shared_path/gprsec/images/ctb.xpm"),
			-border=>1, -bg=>'white');
			$graf[$x]->pack(-side=>'left');
		}
	}
}

# if the user close the read2.pl's window the connection must to be terminated
sub diskonnect {
	$veger=$kapcswin->Label(-fg=>'red', -width=>50, -height=>5)->pack();
	kill_pppd();
exit;
#$veger->configure( text=>"-$pid_pppd-, -$pid_read2-, -$pid_chat"); # na ez mi a ltr?
}
		
sub kill_pppd {
#	$pidin=`ps -C pppd`;
#	@ideig=split /\n/,$pidin;
#	if ($ideig[1]) {
#		@elemek=split / /, $ideig[1];
#		$pid_pppd=$elemek[0];
#		print "-$elemek[0]-";
#		#`kill -s 2 $pid_pppd`;
#	}
#	$pidin=`ps -C chat`;
#	@ideig=split /\n/,$pidin;
#	if ($ideig[1]) {
#		@elemek=split / /, $ideig[1];
#		$pid_chat=$elemek[1];
#		#`kill -s 9 $pid_chat`;
#	}
}


# evaluation of data transmission and showing of data
sub devs {
	($mpx, $percx, $orax, $napx, $honapx)=localtime;
	$honapx++;
	if ($havit_v && $havit_v<=$napx && $honapx>$honap || $honap+2<=$honapx) {
		# erase of data
			foreach (qw/osszb_fel osszb_le/) {
				if (-e "$home/.gprsec/$_") {
				`rm '$home/.gprsec/$_'`;
				}
			}
		undef $ob_f_v;
		undef $ob_l_v;
		# begin of saving of statistic data

		read_config_file();
		
		($mp, $perc, $ora, $nap, $honap, $ev)=localtime();
		$honap++;
		$ev+=1900;
		$temp[13]="  $ev/$honap/$nap $ora;$perc";
		$temp[26]=$honap;

		write_config_file();
		
		read_conf ();
	}

	$last_bytes=$szamok[2];
	$last_bytes_fel=$szamok[10];
	$last_cs_le=$szamok[3];
	$last_cs_fel=$szamok[11];

	# reading of datatransmission

	if ($m_KernelName eq "Linux") {
		$info=`cat /proc/net/dev`;
		@lines=split /\n/, $info;
		foreach (@lines) {
			if (/ppp/) {
				$lines_darab=$_;
				$lines_darab=~s /\:/\:  /; #/
			}
		}
	@szamok=split / +/, $lines_darab;
	}

	if ($m_KernelName eq "FreeBSD") {
		$info=`netstat -SI ppp0 -ib`;
		#$info=`netstat -I rl0 -ib`; # temperaly for rl(eth)0
		@lines=split /\n/, $info;
		@elements=split /\s+/, $lines[2];
	#	@elements=split /\s+/, $lines[3]; # temperaly for rl(eth)0
		$szamok[2]=$elements[6]; # downloaded bytes
		$szamok[10]=$elements[9]; # uploded bytes
		$szamok[3]=$elements[4]; # downloaded packets
		$szamok[11]=$elements[7]; # uploaded packets
	}

	# allocate of momentary download speed
	$ad_lb=(int((($szamok[2]-$last_bytes)/1024)*10))/10;

	# allocate of momentary upload speed
	$ad_fb=(int((($szamok[10]-$last_bytes_fel)/1024)*10))/10;

	# calculating of all downloaded bytes
	$ad_le_b_v+=$szamok[2]-$last_bytes;
	$m_egy1=" byte";
	$oszb1=$ad_le_b_v;
	if ($ad_le_b_v>1024) {
		$oszb1=int(($ad_le_b_v/1024)*100)/100;
		$m_egy1=" kB";

	}
	$mb=1024*1024;
	if ($ad_le_b_v>$mb) {
		$oszb1=int(($ad_le_b_v/$mb)*1000)/1000;
		$m_egy1=" MB";
	}

	# calculating of all uploaded bytes
	$ad_fel_b_v+=$szamok[10]-$last_bytes_fel;
	$m_egy2=" byte";
	$oszb2=$ad_fel_b_v;
	if ($ad_fel_b_v>1024) {
		$oszb2=int(($ad_fel_b_v/1024)*100)/100;
		$m_egy2=" kB";
	}
	$mb=1024*1024;
	if ($ad_fel_b_v>$mb) {
		$oszb2=int(($ad_fel_b_v/$mb)*1000)/1000;
		$m_egy2=" MB";
	}

	# all packages down
	$ad_le_cs_v+=($szamok[3]-$last_cs_le);

	# all packages up
	$ad_fel_cs_v+=($szamok[11]-$last_cs_fel);

	# totally downloaded bytes
	$ob_l_v+=$ad_le_b_v-$last_bytes;
	$m_egy3=" byte";
	$oszb3=$ob_l_v;
	if ($ob_l_v>1024) {
		$oszb3=int(($ob_l_v/1024)*100)/100;
		$m_egy3=" kB";
	}
	$mb=1024*1024;
	if ($ob_l_v>$mb) {
		$oszb3=int(($ob_l_v/$mb)*1000)/1000;
		$m_egy3=" MB";
	}

	# totally uploaded bytes
	$ob_f_v+=$ad_fel_b_v-$last_bytes_fel;
	$m_egy4=" byte";
	$oszb4=$ob_f_v;
	if ($ob_f_v>1024) {
		$oszb4=int(($ob_f_v/1024)*100)/100;
		$m_egy4=" kB";
	}
	$mb=1024*1024;
	if ($ob_f_v>$mb) {
		$oszb4=int(($ob_f_v/$mb)*100)/100;
		$m_egy4=" MB";
	}

	# totally transmitted bytes
	$osszfl=$ob_l_v+$ob_f_v;
	$m_egy5=" byte";
	$oszb5=$osszfl;
	if ($osszfl>1024) {
		$oszb5=int(($osszfl/1024)*100)/100;
		$m_egy5=" kB";
	}
	$mb=1024*1024;
	if ($osszfl>$mb) {
		$oszb5=int(($osszfl/$mb)*100)/100;
		$m_egy5=" MB";
	}

	# the avarage spped of active data transmission
	if (($ad_lb!=0 && $ad_lb>0.1) || ($ad_fb!=0 && $ad_fb>0.1)) { # a 0.1 szrs az adatletlts "beindulsa" miatt szksges
		$seb_stat++;
		$atl_seb_o+=$ad_lb+$ad_fb;
		$atl_seb=$atl_seb_o/$seb_stat;
		$atl_seb=int($atl_seb*10)/10;
		$akt_atl_v->configure(-text=>"$atl_seb kB/s");
	}
	# connection time
	$mtime++;
	$ora=int($mtime/3600);
	$perc=int(($mtime-($ora*3600))/60);
	$mperc=$mtime-($ora*3600)-($perc*60);

	if ((length $mperc)==1) {$mperc="0".$mperc}
	if ((length $perc)==1) {$perc="0".$perc}
	if ((length $ora)==0) {$ora="00".$ora_v}
	if ((length $ora)==1) {$ora="0".$ora}

	# all connections' time

	$kapcs_idok++;
	$time_o=int($kapcs_idok/3600);
	$time_p=int(($kapcs_idok-($time_o*3600))/60);
	$time_mp=$kapcs_idok-($time_o*3600)-($time_p*60);

	if ((length $time_mp)==1) {$time_mp="0".$time_mp}
	if ((length $time_p)==1) {$time_p="0".$time_p}
	if ((length $time_o)==1) {$time_o="0".$time_o}
	if ((length $time_o)==0) {$time_o="00".$time_o}

	$tempfilename=">$home/.gprsec/ossz_ido";
	open (FILE, $tempfilename);
	chmod 0666, $tempfilename;
	print FILE "$kapcs_idok";
	close FILE;
	$tempfilename=">$home/.gprsec/osszb_le";
	open (FILE, $tempfilename);
	chmod 0666, $tempfilename;
	print FILE $ob_l_v;
	close FILE;
	$tempfilename=">$home/.gprsec/osszb_fel";
	open (FILE, $tempfilename);
	chmod 0666, $tempfilename;
	print FILE $ob_f_v;
	close FILE;

	
	
	# data transmisssion in the last 7 days
	
	$mainap=time;
	$mainap=int($mainap/86400);
	undef $all7day;

	$DAYS{$mainap}+=$szamok[2]-$last_bytes+$szamok[10]-$last_bytes_fel;
	foreach $key (keys %DAYS) {
		if ($key<=$mainap-7) {
			delete $DAYS{$key};
		}
	}
	foreach $key (keys %DAYS) {
		$all7day+=$DAYS{$key};
	}
	
	$timenow=time;
	if ($timenow-$indtime>=60) {
		$indtime=time;
		write_last7days();
	}

	
	# prefixes of the last 7 days' data transmission
	$m_egy6=" byte";
	$oszb6=$all7day;
	if ($all7day>1024) {
		$oszb6=int(($all7day/1024)*100)/100;
		$m_egy6=" kB";
	}
	$mb=1024*1024;
	if ($all7day>$mb) {
		$oszb6=int(($all7day/$mb)*100)/100;
		$m_egy6=" MB";
	}

	#########
	#showing of data
	#########

	$ad_l_pill->configure(-text=>"$ad_lb kB/s");
	$ad_lefel=$ad_lb+$ad_fb;
	$readwin->title ("$ad_lefel kB/s ".lancolas($cl[25]));
	$ad_f_pill->configure(-text=>"$ad_fb kB/s");
	$ad_le_b->configure(-text=>"$oszb1 $m_egy1");
	$ad_fel_b->configure(-text=>"$oszb2 $m_egy2");
	$ad_le_cs->configure(-text=>"$ad_le_cs_v");
	$ad_fel_cs->configure(-text=>"$ad_fel_cs_v");
	$ob_l->configure(-text=>"$oszb3 $m_egy3");
	$ob_f->configure(-text=>"$oszb4 $m_egy4");
	$kapcs_t_v->configure(-text=>"$ora:$perc:$mperc");
	$kapcs_o_v->configure(-text=>"$time_o:$time_p:$time_mp");
	$regtimekezd_v->configure(-text=>$reg_time); #kezdet ideje

	# limit monitoring's watching algorythm
	$havilimit_v90=(($havilimit_v*90)/100)*1024*1024*1024; # havi limit gigabjtban
	if ($havilimit_v90<=$osszfl && $havilimit_v) {
		if ($hav_fenn==1) {
			$hav_fenn=0;
			$hat_on="off";
			onoff ();
			$readwin->focusForce;
			$readwin->raise();
			$readwin->deiconify;
		}
		if ($hav_vill==0) {
			$osszlefel_sz->configure(-fg=>'red', -text=>"$oszb5 $m_egy5");
			$osszlefel_sz_sz->configure(-fg=>'red'); #sszesen Forgalmazott adatmennyisg:
			if (!$b1_1) {
				$b1_1 = $hat->Balloon(-bg=>'yellow');
				$b1_1->attach($osszlefel_sz_sz,-msg=>lancolas($cl[117]));
			}
		} else {
			$osszlefel_sz->configure(-fg=>'blue', -text=>"$oszb5 $m_egy5");
			$osszlefel_sz_sz->configure(-fg=>'black'); #sszesen Forgalmazott adatmennyisg:
		}
		$hav_vill=abs($hav_vill-1);
	}  else {
		$osszlefel_sz->configure(-fg=>'blue', -text=>"$oszb5 $m_egy5");
		$hav_fenn=1;
	}

	$hetilimit_v90=(($hetilimit_v*90)/100)*1024*1024; # heti limit megabjtban
	if ($hetilimit_v90<=$all7day && $hetilimit_v) {
		if ($het_fenn==1) {
			$het_fenn=0;
			$hat_on="off";
			onoff ();
			$readwin->focusForce;
			$readwin->raise();
			$readwin->deiconify;
		}
		if ($het_vill==0) {
			$hetiforg_v->configure(-fg=>'red', -text=>"$oszb6 $m_egy6");
			$hetiforg_sz->configure(-fg=>'red'); #heti forgalom
			if (!$b2_1) {
				$b2_1 = $hat->Balloon(-bg=>'yellow');
				$b2_1->attach($hetiforg_sz,-msg=>lancolas($cl[118]));
			}
		} else {
			$hetiforg_v->configure(-fg=>'#0f6039', -text=>"$oszb6 $m_egy6");
			$hetiforg_sz->configure(-fg=>'black');
		}
		$het_vill=abs($het_vill-1);
	}  else {
		$hetiforg_v->configure(-fg=>'#0f6039', -text=>"$oszb6 $m_egy6");
		$hetiforg_sz->configure(-fg=>'black');
		$het_fenn=1;
	}


	# specilis statiszikai adatok mentse (ha a pill. seb>0.1, akkor mentse)
	if ($ad_lb>0.1) {
		open (FILE, "<$home/.gprsec/sp_stat");
		while ($sor=<FILE>) {
			push (@alap, $sor);
		}
		close FILE;
		($mp5, $perc5, $ora5)=localtime;
		$dikp5=$ora5*60+$perc5;
		$dik5=int($dikp5/5);
		foreach (@alap) {
			@sorelemek=split/\:/, $_;
			if ($sorelemek[0]==$dik5) {
				$sorelemek[1]++;
				$ujossz=($sorelemek[2]+$ad_lb);
				$ujatl=(int(($ujossz/$sorelemek[1])*10))/10;
				$_="$sorelemek[0]:$sorelemek[1]:$ujossz:$ujatl\n";
			}
		}
		$tempfilename=">$home/.gprsec/sp_stat";
		open (FILE, $tempfilename);
		chmod 0666, $tempfilename;
		foreach (@alap) {
			print FILE $_;
		}
		undef @alap;
		close FILE;
	}
} # az adatforgalomra vonatkoz kirtkelsek, megjelentsek, stb. ---> VGE


# a statisztikai adatok megjelentse, elrejtse
sub onoff {
	if ($hat_on eq "on") {
		$hat_on="off";
		$readwin->geometry('523x138');
		$readwin->maxsize('523','138');
		$readwin->minsize('523','138');
	} else {
		$readwin->geometry('523x495');
		$readwin->maxsize('523','455');
		$readwin->minsize('523','455');
		$hat_on="on";
	}
}

# showing the diagram data
sub spec_stat {
	if ($specwinn) {
		$specwinn->focusForce;
		$specwinn->raise();
		$specwinn->deiconify;
		return;
	}
	$specwinn=MainWindow->new();
	$specwinn->OnDestroy(\sub {undef $specwinn});

	$specwinn->title (lancolas($cl[44])); #Specilis statisztikai bra
	$specwinn->maxsize('400','410');
	$specwinn->minsize('400','410');
	$grafframe=$specwinn->Frame()->pack();
	$kommframe=$specwinn->Frame()->pack();

	graf ();

	$komm_fel=$kommframe->Frame()->pack(-side=>'top');
	$komm_le=$kommframe->Frame()->pack(-side=>'bottom');
	$close_frame=$komm_le->Frame()->pack(-side=>'bottom');
	$diag_cl_butt=$close_frame->Button(-fg=>'red', -activeforeground=>'red', -text=>lancolas($cl[83]), -command=>sub {$specwinn->destroy; undef $specwinn})->pack(); #Ablak bezrsa
	$nbutton1=$komm_fel->Button(-text=>lancolas($cl[45]), -command=>\&ad_ki)->pack(-side=>'left'); #Adatok kiegsztse nlkl
	$nbutton2=$komm_fel->Button(-text=>lancolas($cl[46]), -command=>\&ad_be)->pack(-side=>'left'); #Adatok kiegsztsvel
	$nbutton3=$komm_le->Button(-text=>lancolas($cl[47]), -command=>\&von)->pack(-side=>'left'); #Vonaldiagramm
	$nbutton4=$komm_le->Button(-text=>lancolas($cl[48]), -command=>\&osz)->pack(-side=>'left'); #Oszlopdiagramm



	$il=$jd = $grafframe->repeat(300000,=>\sub {$sback->destroy; undef @yok; undef @soroks; graf()}); # flpercenknt frissti a diagrammot

MainLoop ();

	sub ad_ki { # adatok kiegsztse ki
		$sback->destroy;
		undef $ki;
		undef @yok;
		undef @soroks;
		graf ();
	}

	sub ad_be { # adatok kiegsztse be
		$sback->destroy;
		$ki="yes";
		undef @yok;
		undef @soroks;
		graf ();
	}

	sub von { # vonaldiagram
		$sback->destroy;
		undef $st;
		undef @yok;
		undef @soroks;
		graf ();
	}

	sub osz { #oszlopdiagram
		$sback->destroy;
		$st="osz";
		undef @yok;
		undef @soroks;
		graf ();
	}

	# grafikus fellet
	sub graf {
		undef @yok; # a rgi betlttt adatok trlse

		$sback=$grafframe->Canvas(-width=>400, -height=>320, -bg=>"gray")->pack();
		$cim_sz=$sback->Label(-bg=>'gray', -text=>lancolas($cl[49])); # A pillanatnyi letltsi sebessgek 5...

		$ycim=$sback->Label(-bg=>'gray', -text=>"kB/s");
		$sback->createWindow(7, 150, -window=>$ycim, -anchor=>'nw');
		$xcim=$sback->Label(-bg=>'gray', -text=>lancolas ($cl[53])); #ra
		$sback->createWindow(200, 305, -window=>$xcim, -anchor=>'center');


		open (FILE, "<$home/.gprsec/sp_stat");
		while ($sor=<FILE>) {
			@temp=split/\:/, $sor;
			push (@soroks, $temp[3]);
			$nagyatl+=$temp[3];
			if ($temp[3]>0) {$spszam++}
		}
		$oldy=270-(30*$soroks[1]);
		for ($i=1; $i<=288; $i++) {
			$xhely=60+$i;
			$yhely_k=270-(30*$soroks[$i]);
			push (@yok, $xhely);
			if ($yhely_k==270 && $ki eq "yes") {
				$yhely_k=$oldy;
			}
			push (@yok, $yhely_k);
			if ($st) {
				$sback->createLine($xhely, $yhely_k, $xhely, 270, -fill=>'red'); #oszlop
			}
			$oldy=$yhely_k;
		}
		if (!$st) {
			$sback->createLine(@yok, -fill=>'red', -width=>1); #vonal
		}
		if ($spszam) { # ha mg nincs statisztikai llomnyban adat, akkor nullval akar osztani :-)
			$kbsatlag=(int(($nagyatl/$spszam)*10))/10;
		} else {$kbsatlag=0}
		$sback->createLine(55, 270-(30*$kbsatlag), 355, 270-(30*$kbsatlag), -fill=>'white', -width=>2); #nagytlag
		$nagyatl_cimke=$sback->Label(-bg=>'gray', -text=>"$kbsatlag");
		$sback->createWindow(375, 270-(30*$kbsatlag), -window=>$nagyatl_cimke, -anchor=>'center');
		undef $nagyatl;
		undef $spszam;
		# koordintarendszer
		$sback->createWindow(200, 20, -window=>$cim_sz, -anchor=>'center');
		$sback->createLine(60, 270, 348, 270);
		$sback->createLine(60, 270, 60, 40, -arrow=>'last');
		$sback->createLine(60, 267, 348, 267, -fill=>'#992f2f', -stipple=>'@'.("$gprs_shared_path/gprsec/images/grey.25"));
		foreach (qw/1 2 3 4 5 6 7/){
			$yten[$_]=$sback->Label(-bg=>'gray', -text=>"$_");
			$ytav=270-($_*30);
			$sback->createWindow(50, $ytav, -window=>$yten[$_], -anchor=>'center');
			$sback->createLine(55, $ytav, 65, $ytav);
			$sback->createLine(65, $ytav, 348, $ytav, -stipple=>'@'.("$gprs_shared_path/gprsec/images/grey.25"));
		}

		$sz_03=$sback->Label(-bg=>'gray', -text=>"0.1");
		$sback->createWindow(56, 267, -window=>$sz_03, -anchor=>'e');
		for ($i=0; $i<=24; $i++) {
			$xten[$i]=$sback->Label(-bg=>'gray', -text=>"$i");
			$xtav=$i*12+60;
			$sback->createLine($xtav,265, $xtav, 275);
			if ($i/2==int($i/2)) {
				$xcim0=$sback->Label(-bg=>'gray', -text=>"$i");
				$sback->createWindow($xtav, 285, -window=>$xcim0, -anchor=>'center');
			}
		}
	}
}


sub nyelvbeolv {
# nyelvi adatok beolvassa
# elszr az angolt olvassa be,
# majd a meglv sorokkal fellrja (gy, ha hinyzik
# a fordtsbl a sor, akkor helyette angol jelenik meg)
	undef $clx;
	undef @temp_cl;
	$temp_cl[0]=" ";
	open (FILE, "<$gprs_shared_path/gprsec/languages/english");
	binmode FILE;
	while ($sor=<FILE>) {
		chomp $sor;
		$sor=~s /\\n/\n/g;
		binmode $sor;
		push (@temp_cl, $sor);
	}

	$cl[0]=" ";
	open (FILE, "<$gprs_shared_path/gprsec/languages/$sel_lang");
	binmode FILE;
	while ($sor=<FILE>) {
		chomp $sor;
		$sor=~s /\\n/\n/g;
		binmode $sor;
		push (@cl, $sor);
	}
	#angol szvegre trtn behelyettests
	$tempsl_len=@temp_cl;
	for ($clx=0; $clx<=$tempsl_len; $clx++) {
		if (!$cl[$clx] && $temp_cl[$clx]) {
			$cl[$clx]=$temp_cl[$clx];
		}
	}
}


sub lancolas {
	# a szvegkkirats szubrutinja
	undef $kirak;
	undef $po;
	@l_temp=split /\*\*\*/, $_[0];
	foreach (@l_temp) {
		$po++;
		$kirak.="$_$_[$po]";
	}
	return $kirak;
}


# a config beolvassa
sub read_conf {

	# read previous (new) configs
	undef @spl;
	undef @spl_comment;
	open (FILE, "<$home/.gprsec/EasyConn.config");
		while ($sor=<FILE>) {
			@spl_temp=split /\#/, "$sor";
			push (@spl, $spl_temp[0]);
			push (@spl_comment, "#".$spl_temp[1]);
		}
	close FILE;

	$phonetype=$spl[0];
	$kivp=$spl[1];
	$co_pan=$spl[2];
	$brow=$spl[3];
	$br_on=$spl[4];
	$autocsat=$spl[5];
	$sel_lang=$spl[6];
	$cw_ic=$spl[7];
	$sel_szolg=$spl[8];
	$user=$spl[9];
	$passw=$spl[10];
	$reconn_on=$spl[11];
	$idores=$spl[12];
	$reg_time=$spl[13];
	$din_eng=$spl[14];
	$cid=$spl[15];
	$dns1=$spl[16];
	$dns2=$spl[17];
	$no_beep=$spl[18];
	$bg_rec=$spl[19];
	$reconn_db=$spl[20];
	$no_cgq=$spl[21];
	$other_numb=$spl[22];
	$havit_v=$spl[23];
	$havilimit_v=$spl[24];
	$hetilimit_v=$spl[25];
	$honap_old=$spl[26];
	$no_auth=$spl[27];
	$debug=$spl[28];
	$bsd_comp=$spl[29];
	$connspeed=$spl[30];
	$no_dev=$spl[31];
	$no_find=$spl[32];
	$connspeed=$spl[30];
	$no_dev=$spl[31];
	$def_apn=$spl[33];
	$compact=$spl[34];
	$newly=$spl[35];
	$apnid=$spl[36];
 	chomp ($apnid);
}

# a kapcsolatmegszakadsnak jelzse a fprogramnak
sub reconn {
	$tempfilename=">$home/.gprsec/disc";
	open (FILE, $tempfilename);
	chmod 0666, $tempfilename;
	close FILE;
}

# hangjlezs
sub beep {
	if ($no_beep !=1) {
		$readwin->bell;
	}
}
# mg nem tesztelt kszlkkel trtn csatlakozs
sub findnotested {
	if ($find_win) {
		$find_win->focusForce;
		$find_win->raise();
		$find_win->deiconify;
		return;
	}
	$find_win=MainWindow->new();
	$find_win->title ("Connected with a non-tested phone!");
	$find_win->OnDestroy(sub {find_ex2()});
			$find_winx=$xfele-225;
			$find_winy=$yfele-200;
			$find_win->geometry("+$find_winx+$find_winy");
	$find_win->maxsize('450','400');
	$find_win->minsize('450','400');
	$find_sz[0]=$find_win->Label(-fg=>'blue', -text=>lancolas($cl[153]))->pack(); #gy tnik olyan kszlkkel kapcsoldtl\nsikeresen, amelynek mg \"hivatalosan\" nincs tesztere!\nHa kedved van hozz, akkor, lgy szves tltsd ki az albbi rlapot:
	$find_sz[1]=$find_win->Label(-text=>lancolas($cl[154]))->pack();#Neved?
	$find_sz[2]=$find_win->Entry()->pack;
	$find_sz[3]=$find_win->Label(-text=>lancolas($cl[155]))->pack();#E-mail cmed?
	$find_sz[4]=$find_win->Entry()->pack;
	$find_sz[5]=$find_win->Label(-text=>lancolas($cl[156]))->pack();#Disztribcid?
	$find_sz[6]=$find_win->Entry()->pack;
	$find_sz[7]=$find_win->Label(-text=>lancolas($cl[157]))->pack();#Egyb kzlemny?
	$find_sz[8]=$find_win->Text(-width=>"50", -height=>"5")->pack();
	$find_sz[9]=$find_win->Label()->pack();
	$find_sz[10]=$find_win->Checkbutton(-fg=>"blue", -text=>lancolas($cl[158]), -variable=>\$no_find, -command=>\&find_no)->pack();#Ksz, de ez az ablak ne jelenjen meg legkzelebb!
	$find_sz[11]=$find_win->Button(-text=>lancolas($cl[93]), -command=>\&find_ok)->pack(-side=>"left", -padx=>20);#Ok
	$find_sz[12]=$find_win->Button(-text=>lancolas($cl[57]), -command=>\&find_ex)->pack(-side=>"right", -padx=>20);#Mgsem
	MainLoop();
	# kilps a teszteletlen telefonnal kapcsolatos krds ablakbl
	sub find_ex {
			$find_win->destroy;
			undef $find_win;
		    }

	# ha nem kvnja a felhasznl, hogy ismtelten megjelenjen az ablak, akkor a konfigurcis
	# llomnyba ezt elmenti a program, majd bezrja az ablakot
	sub find_no{
		if ($no_find) {
		
		new_config_save();
			
			#read_config_file();

			#$temp[32]=$no_find;

			#write_config_file();

		find_ex();
		return;
		}
	}
	# az adatokat elkldi http protokolon keresztl a szervernek, ha minden szksges adat megvan
	sub find_ok{

		undef $ad_x;
		undef %nincsadat;
		#szksges adatok ellenrzse
		$find_name=$find_sz[2]->get;
			if (!$find_name) {
				$nincsadat{$ad_x}=lancolas($cl[160]);
				$ad_x++;
			}
		$find_emil=$find_sz[4]->get;
			if (!$find_emil) {
				$nincsadat{$ad_x}=lancolas($cl[161]);
				$ad_x++;
			}
		$find_disztr=$find_sz[6]->get;
			if (!$find_disztr) {
				$nincsadat{$ad_x}=lancolas($cl[162]);
				$ad_x++;
			}
		$find_disztr.=$dist_kern;
		if ($ad_x) {
			find_hiba();
			return;
		}
		$find_egyeb=$find_sz[8]->get('0.0','end');
		$find_egyeb=~ tr/\n/ /;
		$find_tel=$phonetype;
		$find_port=$kivp;
		$find_sz[2]->configure(-state=>"disable");
		$find_sz[4]->configure(-state=>"disable");
		$find_sz[6]->configure(-state=>"disable");
		$find_sz[8]->configure(-state=>"disable");
		$find_sz[10]->configure(-state=>"disable");
		$find_sz[11]->configure(-state=>"disable");
		$find_sz[12]->configure(-state=>"disable");

		$find_win1=MainWindow->new();
		$find_win1->title ("Connection");
		$find_win1->OnDestroy(sub {find_ex2()});
			$find_winx1=$xfele-150;
			$find_winy1=$yfele-25;
			$find_win1->geometry("+$find_winx1+$find_winx1");
		$find_win1->maxsize('300','50');
		$find_win1->minsize('300','50');

		
		$find_egyeb.=" - GPRS EC Version $ver";

		$find_name=~tr /\:\#//d; #/
		$find_emil=~tr /\:\#//d; #/
		$find_disztr=~tr /\:\#//d; #/
		$find_egyeb=~tr /\:\#//d; #/
		$find_port=~tr /\:\#//d; #/
		$doc= get ("http://www.easyconnect.linuxuser.hu/test.php?name=$find_name&mail=$find_emil&phone=$find_tel&port=$find_port&kernel=$find_disztr&note=$find_egyeb");
		chomp $doc;
		if ($doc eq "1") {
			$nincs=$find_win1->Label(-fg=>'red', -text=>lancolas($cl[159]))->pack(); #Az adatok elkldse sikeres!
		} else {
			$nincs=$find_win1->Label(-text=>lancolas($cl[142]))->pack();#Nem tudtam kapcsoldni a szerverhez!
		}
			$kilep=$find_win1->Button(-text=>lancolas($cl[93]), -command=>\sub {$find_win->destroy})->pack();#Ok
		sub find_ex2 {
			$find_win->destroy;
			undef $find_win;
			if ($find_win1) {
				$find_win1->destroy;
				undef $find_win1;
			}
		}
	}
return;
}

sub find_hiba {
	foreach $kulcsok (keys %nincsadat) {
	$hibaszoveg.=$nincsadat{$kulcsok}."\n";
	}
	hiba ($hibaszoveg)
}

sub hiba {
	if ($hibawin) {
			if ($no_beep !=1) {
				$hibawin->bell;
			}
			$hibawin->focusForce;
			$hibawin->raise();
			$hibawin->deiconify;
			return;
	}
	$hibawin=MainWindow->new();
	if ($no_beep !=1) {
		$hibawin->bell;
	}

	$hibaszoveg=$_[0];
	$hibawin->title($cl[11]);
			$hibawinx=$xfele-100;
			$hibawiny=$yfele-100;
			$hibawin->geometry("+$hibawinx+$hibawiny");
	$hszoveg=$hibawin->Label(-fg=>'red', -text=>"$hibaszoveg")->pack();
	$hbutt=$hibawin->Button(-text=>"Ok", -command=>\&hshut)->pack();

	sub hshut {
		$hibawin->destroy;
		undef $hibawin;
	}
undef $hibaszoveg;
return;
}

sub write_last7days {
	# write the data transmisssion in the last 7 days
	dbmopen (%NAP, "$home/.gprsec/7d", 0666);
	%NAP=%DAYS;
	close %NAP;
}

sub read_config_file {
		# read previous (new) configs
		undef @temp;
		undef @temp_comment;
		open (FILE, "<$home/.gprsec/EasyConn.config");
		while ($sor=<FILE>) {
			@temp_temp=split /\#/, "$sor";
			push (@temp, @temp_temp[0]);
			push (@temp_comment, "\#".@temp_temp[1]);
		}
		close FILE;
}

sub write_config_file {
	$tempfilename=">$home/.gprsec/EasyConn.config";
	open (FILE, $tempfilename);
	chmod 0666, $tempfilename;
	undef $newconfig_file;
	$temp_lenght=@temp;
	for (my $x=0; $x<=$temp_lenght; $x++) {
		$newconfig_file.="$temp[$x]"."@temp_comment[$x]"
	}
	print FILE $newconfig_file;
	close FILE;	

}

sub new_config_save{
	$tempfilename=">$home/.gprsec/EasyConn.config";
	open (FILE, $tempfilename);
	chmod 0666, $tempfilename;

	my $configfile="";
	$configfile.=$phonetype."#\t\t\t"."phone type\n";
	$configfile.=$kivp."#\t\t\t"."selected port\n";
	$configfile.=$co_pan."#\t\t\t"."connect window to panel?\n";
	$configfile.=$brow."#\t\t\t"."start this browser\n";
	$configfile.=$br_on."#\t\t\t"."enable starting of a browser\n";
	$configfile.=$autocsat."#\t\t\t"."enable automatic connection\n";
	$configfile.=$sel_lang."#\t\t\t"."language\n";
	$configfile.=$cw_ic."#\t\t\t"."main window to panel?\n";
	$configfile.=$sel_szolg."#\t\t\t"."selected provider\n";
	$configfile.=$user."#\t\t\t"."username\n";
	$configfile.=$passw."#\t\t\t"."password\n";
	$configfile.=$reconn_on."#\t\t\t"."reconnect after the disconnect in xx sec.\n";
	$configfile.=$idores."#\t\t\t"."time interval. of the watching buliding connection\n";
	$configfile.=$reg_time."#\t\t\t"."date of starting of data's save\n";
	$configfile.=$din_eng."#\t\t\t"."enable dynamic DNSs\n";
	$configfile.=$cid."#\t\t\t"."own CID number\n";
	$configfile.=$dns1."#\t\t\t"."own DNS1\n";
	$configfile.=$dns2."#\t\t\t"."own DNS2\n";
	$configfile.=$no_beep."#\t\t\t"."disable warning beep\n";
	$configfile.=$bg_rec."#\t\t\t"."reconnect in the backround\n";
	$configfile.=$reconn_db."#\t\t\t"."number of enabled reconnections\n";
	$configfile.=$no_cgq."#\t\t\t"."disable CGQ commands\n";
	$configfile.=$other_numb."#\t\t\t"."own calling number\n";
	$configfile.=$havit_v."#\t\t\t"."date of erase of monthly limit's data\n";
	$configfile.=$havilimit_v."#\t\t\t"."monthly limit\n";
	$configfile.=$hetilimit_v."#\t\t\t"."weekly limit\n";
	$configfile.=$honap."#\t\t\t"."month of last erase\n";
	$configfile.=$no_auth."#\t\t\t"."Do not require the peer to authenticate itself\n";
	$configfile.=$debug."#\t\t\t"."debug mode on\n";
	$configfile.=$bsd_comp."#\t\t\t"."enable BSD compression\n";
	$configfile.=$connspeed."#\t\t\t"."connection speed\n";
	$configfile.=$no_dev."#\t\t\t"."disable read/write data during connection\n";
	$configfile.=$no_find."#\t\t\t"."disabe the sending of info of new tested phone\n";
	$configfile.=$def_apn."#\t\t\t"."own APN\n";
	$configfile.=$compact."#\t\t\t"."compact mode\n";
	$configfile.=$newly."#\t\t\t"."newly set data\n";
	$configfile.=$szolg_apn{$sel_szolg}[0]."#\t\t\t"."APN ID\n";
	
	print FILE $configfile;
	close FILE;
}